import java.awt.Graphics;
import java.lang.Math;

public class MouseTrack extends java.applet.Applet {

    // mx, my are the mouse x and y positions
    int mx, my;

    // onaroll counts the number of times in a row you hit
    int onaroll;

    // init - set the window size and let it go at that
    public void init() {
    onaroll = 0;
    resize(500, 500);
    }

    // paint - paint target rectangle
    public void paint(Graphics g) {
    // start by drawing a bounding rectangle around entire
    // window
    g.drawRect(0, 0, size().width - 1, size().height - 1);

    // now calculate a random location for the target window
    // and draw it there
    mx = (int)(Math.random()*1000) %
                       (size().width - (size().width/10));
    my = (int)(Math.random()*1000) %
                       (size().height - (size().height/10));
    g.drawRect(mx, my,
               (size().width/10) - 1,
               (size().height/10) - 1);
    }

    /*
     * Mouse methods
     */
    // mouseDown - determine if you got a hit
    public boolean mouseDown(java.awt.Event evt, int x, int y) {
    requestFocus();
    if((mx < x && x < mx+size().width/10-1) &&
       (my < y && y < my+size().height/10-1)) {
        if(onaroll > 0) {
        switch(onaroll%4) {
        case 0:
            play(getCodeBase(),
                           "sounds/tiptoe.thru.the.tulips.au");
            break;
        case 1:
            play(getCodeBase(), "sounds/danger,danger...!.au");
            break;
        case 2:
            play(getCodeBase(), "sounds/adapt-or-die.au");
            break;
        case 3:
            play(getCodeBase(), "sounds/cannot.be.completed.au");
            break;
        }
        onaroll++;
        if(onaroll > 5)
            getAppletContext().showStatus(
                    "You're on your way to THE HALL OF FAME:"
                    + onaroll + "Hits!");
        else
            getAppletContext().showStatus(
                     "YOU'RE ON A ROLL:" + onaroll + "Hits!");
        }
        else {
        getAppletContext().showStatus("HIT IT AGAIN! AGAIN!");
        play(getCodeBase(), "sounds/that.hurts.au");
        onaroll = 1;
        }
    }
    else {
        getAppletContext().showStatus(
           "You hit nothing at (" + x + ", " + y + "), exactly");
        play(getCodeBase(), "sounds/thin.bell.au");
        onaroll = 0;
    }
    repaint();
    return true;
    }

    // mouseMove - repaint the rectangle whenever the mouse
    //             moves, enters the window, or exits the
    //             window
    public boolean mouseMove(java.awt.Event evt, int x, int y) {
    if((x % 3 == 0) && (y % 3 == 0))
        repaint();
    return true;
    }

    public void mouseEnter() {
    repaint();
    }

    public void mouseExit() {
    onaroll = 0;
    repaint();
    }

    /**
     * Focus methods
     */
    public void keyDown(int key) {
    requestFocus();
    onaroll = 0;
    play(getCodeBase(), "sounds/ip.au");
    }
}
