//------------------------------------------------------------------------------
// RWMenu.java:
//		Implementation for menu creation class RWMenu
//
//------------------------------------------------------------------------------
import java.awt.*;

public class RWMenu
{
	Frame   m_Frame        = null;
	boolean m_fInitialized = false;

	// MenuBar definitions
	//--------------------------------------------------------------------------
	MenuBar mb;

	// Menu and Menu item definitions
	//--------------------------------------------------------------------------
	Menu m1;	// File
	MenuItem ID_FILE_OPEN;	// Open
	MenuItem ID_FILE_CLOSE;	// Close
	Menu m4;	// Edit
	MenuItem ID_EDIT_COPY;	// Copy
	MenuItem ID_EDIT_CUT;	// Cut
	MenuItem ID_EDIT_PASTE;	// Paste

	// Constructor
	//--------------------------------------------------------------------------
	public RWMenu (Frame frame)
	{
		m_Frame = frame;
	}

	// Initialization.
	//--------------------------------------------------------------------------
	public boolean CreateMenu()
	{
		// Can only init controls once
		//----------------------------------------------------------------------
		if (m_fInitialized || m_Frame == null)
			return false;

		// Create menubar and attach to the frame
		//----------------------------------------------------------------------
		mb = new MenuBar();
		m_Frame.setMenuBar(mb);

		// Create menu and menu items and assign to menubar
		//----------------------------------------------------------------------
		m1 = new Menu("File");
		mb.add(m1);
			ID_FILE_OPEN = new MenuItem("Open");
			m1.add(ID_FILE_OPEN);
			ID_FILE_CLOSE = new MenuItem("Close");
			m1.add(ID_FILE_CLOSE);
		m4 = new Menu("Edit");
		mb.add(m4);
			ID_EDIT_COPY = new MenuItem("Copy");
			m4.add(ID_EDIT_COPY);
			ID_EDIT_CUT = new MenuItem("Cut");
			m4.add(ID_EDIT_CUT);
			ID_EDIT_PASTE = new MenuItem("Paste");
			m4.add(ID_EDIT_PASTE);

		m_fInitialized = true;
		return true;
	}
}
